//-----------　以下のコードは必要のあるユーザのみ記述する --------------

// もしMain()の開始前に実行しておきたいコードが別にある場合は以下に記述．
// このルーチンの出力はログファイルに記録されません．
void preMain() {
}

// もしMain()終了後に実行しておきたいコードが別にある場合は以下に記述．
// このルーチンの出力はログファイルに記録されません．
void postMain() {
}

// ユーザ独自のmousePressed()
void MousePressed() {
}
// ユーザ独自のmouseRelased()
void MouseReleased() {
}
// ユーザ独自のmouseDragged()
void MouseDragged() {
}
// ユーザ独自のmouseMoved()
void MouseMoved() {
}

float clickedX = 0.0, clickedY = 0.0;
int   _clickedX =0,  _clickedY = 0;
// ユーザ独自のmouseClicked()
void MouseClicked() {
  if (mouseButton == RIGHT) {
    int target = crow.detectActiveView(mouseX, mouseY);
    if (target < 0) return;
    targetView = target;
  } else if (mouseButton == LEFT) {
    int mx, my;
    mx = mouseX; my = height - mouseY;
    crow.lastView().stroke(#800000);
    if (clicked == false) crow.cv.moveTo(mx, my);
      else                crow.cv.dashedLineTo(mx, my, crow.cv._px(5.0));
    clicked = true;
    crow.cv.fill(#202020).stroke(#000000).rectMode(CENTER).rect(mx, my, 10, 10);

    crow.view("Left");
    if (crow.mouseover()) {
      clickedX  = crow.viewMouseX();
      clickedY  = crow.viewMouseY();
      _clickedX = crow._viewMouseX();
      _clickedY = crow._viewMouseY();
//    println(clickedX);
//    println(clickedY);
    }
  }
}
// ユーザ独自のkeyPressed()
void KeyPressed() {
  switch (key) {
    case '1' : crow.toggleViewVisible(0); break;
    case '2' : crow.toggleViewVisible(1); break;
    case '3' : crow.toggleViewVisible(2); break;
    case '4' : crow.toggleViewVisible(3); break;
    case '5' : crow.toggleViewVisible(4); break;
    case 't' :
    case 'T' : crow.viewMoveToTop(targetView); break;
    case 'b' :
    case 'B' : crow.viewMoveToBottom(targetView); break;
    case 'c' :
    case 'C' : crow.lastView(); crow.cv.clrView(); clicked = false; break;
  }
  switch (keyCode) {
    case LEFT  : crow.moveViewRel(targetView, -2,  0); break;
    case RIGHT : crow.moveViewRel(targetView,  2,  0); break;
    case UP    : crow.moveViewRel(targetView,  0, -2); break;
    case DOWN  : crow.moveViewRel(targetView,  0,  2); break;
  }
}
// ユーザ独自のkeyRleased()
void KeyReleased() {
}
// ユーザ独自のkeyTyped()
void KeyTyped() {
  if ((key == 'Q') || (key == 'q')) crow.stop();
}

// もしMain()終了後に通常のProcessingのようにエンドレスに処理を続ける場合は
// Setup()にcrowbar.nonStop()を記述すると共に，以下にコードを記述．
// ユーザ独自のdraw()
int i = 0;
void Draw() {
  int mx, my, i;
  mx = mouseX - 20;
  my = height - mouseY - 20;

//crow.clrAllView();
  // 回転
  crow.view("RightUpper").worldCenter(mx, my).viewRotateRel(1.0).viewPivotCenter();
  for (i = 0; i < crow.viewMax - 1; i++) {
    crow.view(i);
    if (crow.isView("Text")) {
      String textin;
      crow.cv.clrView();
//    println(crow.echo());
      if (crow.inputFinished() > 0) crow.cv._write(0, 15, crow.gets());
        else                        crow.cv._write(0, 16, crow.echo());
      continue;
    }
    if (i == targetView) crow.cv.frameColor(#ff0000);
      else               crow.cv.frameColor(#000000);
    crow.cv.clrView().stroke(#000000).fill(#ffffff).line(0, 0, 1000, 0).line(0, 0, 0, 1000).ellipse(0, 0, 20);
    if (crow.isView("RightUpper")) {
//    crow.cv.triangle(mx, my, 50.0, PI);
      crow.cv.arc(mx, my, 100, 0, 90);
      crow.cv.viewTextColor(#ff0000);
    } else if (crow.isView("RightLower")) {
      crow.cv.triangle(mx, my, 50.0);
      crow.cv.viewTextColor(#ffffff);
    } else {
      crow.cv.ellipseMode(CENTER).ellipse(mx, my, 50.0, 50.0);
      crow.cv.viewTextColor(#000000);
    }
    crow.cv.stroke(#404040).strokeWeight(3).lineTo(0, 0).strokeWeight(1);
    crow.cv.text("Mouse(" + str(mouseX) + "," + str(mouseY) + ")", 50, 50);
  }
  crow.view("Left")._ellipse(_clickedX, _clickedY, 50);
    
/*
  // 曲線で絵を描いてみよう
  crow.cv.noFill();
  crow.cv.curveStart(100, 100).curveRel(50, 0).curveRel(0, 50).curveRel(50, 0).curveEnd();
  crow.cv.plot(100, 100, 5);
  crow.cv.moveToRel(50,  0).plot(5);
  crow.cv.moveToRel( 0, 50).plot(5);
  crow.cv.moveToRel(50,  0).plot(5);
*/

  crow._clrscr();
  fill(#808000);
  stroke(#000000);
  ellipse(mouseX, mouseY, 50, 50);
  line(0, 0, mouseX, mouseY);
  crow._write(cx, cy, "Mouse(")._write(mouseX)._write(",")._write(mouseY)._write(")");
  crow._write(cx, cy + 1, "[1] [2] [3] [4]");
  crow._write(cx, cy + 2, "ビューポートの表示切り替え");
  crow._write(cx, cy + 3, "マウス右クリック：ビューポート選択");
  crow._write(cx, cy + 4, "マウス左クリック：マーク表示");
  crow._write(cx, cy + 5, "[C]: マーク表示画面の消去");
  crow._write(cx, cy + 6, "[T]: 最上面へ [B]: 最下面へ");
  crow._write(cx, cy + 7, "カーソルキー: ビューポート移動");
}

